function [G,H]=GradHess(fname,x,y,varargin)
% (c) 2003 by Marco Maffezzoli. Ver. 2.1.3

xr=size(x,1);
xc=size(x,2);
x=x(:);
n=length(x);
h=diag(eps^(1/3)*max(abs(x),1));
G=zeros(1,n);
H=zeros(n);
y1=zeros(1,n);
for k=1:n
    y1(k)=feval(fname,reshape(x+h(:,k),xr,xc),varargin{:});
    y2=feval(fname,reshape(x-h(:,k),xr,xc),varargin{:});
    G(k)=(y1(k)-y2)/(2*h(k,k));    
end
for k=1:n
    for z=k:n
        y2=feval(fname,reshape(x+h(:,k)+h(:,z),xr,xc),varargin{:});
        H(k,z)=(y2-y1(k)-y1(z)+y)/(h(k,k)*h(z,z));
        H(z,k)=H(k,z);
    end
end