function [s,ns]=Steihaug(r,H,ng,delta)
% Author: Marco Maffezzoli. Ver. 1.0.0, 01/2004.

d=-r;
z=ng^2;
s=zeros(length(r),1);
tol=min(0.5,ng)*ng;
while 1
    gamma=d'*H*d;
    if gamma<=0
        ns=delta;
        s=quadsolve(s,d,delta);
        return
    end
    alpha=z/gamma;
    s1=s+alpha*d;
    ns=norm(s1);
    if ns>=delta
        ns=delta;
        s=quadsolve(s,d,delta);
        return
    end
    s=s1;
    r=r+alpha*H*d;
    z1=r'*r;    
    if sqrt(z1)<=tol
        return
    end
    d=-r+(z1/z)*d;
    z=z1;
end