% Program name: basic_example1_solution.m;


% type 1 for exercise 1; 2 for exercise 2, 5 for exercise 5
exercise = 1;

%warnings('OFF', 'MSGID'); 
 
% Load the data set
% invpc = investment rate (i)
% shc = productivity shock (A)
% prok = profit rate (AK^alpha-1)
load book2;
data = [invpc; shc; prok];


if exercise == 5
p = 1;                      % Normalize price to one
T = length(data);
maxiter = 10;           % Convergence is fast therefore only need two iterations
                        % this is a parameter to play with

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(' exercise 5: allow for higher serial correlation in the error')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Parameters calibrate betta delta, estimate alpha gamma
betta = .95;   
delta = .069;
guess = [1 1]; % this is the initial guess for alpha, gamma

p = 1;                      % Normalize price to one
T = length(data);
maxiter = 10;           % Convergence is fast therefore only need two iterations
                        % this is a parameter to play with
iter = 1;
W = eye(2);             % Step One of the GMM algorithm

     while iter <= maxiter;
        [results,J,ef,out,grad,Hessian]= fminunc(@model1,guess,[],data,betta,delta,p,T,W);
        gamma = results(1);
        alpha = results(2);
        stderrors = sqrt(diag(Hessian));
    
        % Calculate the Optimal Weight Matrix (Step Two)
        k=5;   % order of autocovariances to include in optimal W
        W = varcovx(gamma,alpha,data,betta,delta,p,T,k);
        iter = iter +1;
    end
disp('*****************')
disp('     Results')
disp('*****************')
disp(['Gamma = ' num2str(gamma) ' (' num2str(stderrors(1)) ')'])
disp(['Alpha = ' num2str(alpha) ' (' num2str(stderrors(2)) ')'])
disp(['J statistic = ' num2str(T*J)])
disp('*****************')

elseif exercise == 1                         
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('exercise 1: fix alpha to 0.5 and find optimal gamma')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters calibrate betta delta alpha, estimate gamma
betta = .95;   
delta = .069;
alpha = 0.5;
guess = [1]; % this is the initial guess for gamma

iter = 1;
W = eye(2);             % Step One of the GMM algorithm
p = 1;                      % Normalize price to one
T = length(data);
maxiter = 10;           

while iter <= maxiter;
        [results,J,ef,out,grad,Hessian]= fminunc(@model1_exa1,guess,[],data,betta,delta,alpha,p,T,W);
        gamma = results(1);
        stderrors = sqrt(diag(Hessian));
    
        % Calculate the Optimal Weight Matrix (Step Two)
        k=2;   % order of autocovariances to include in optimal W
        W = varcovx(gamma,alpha,data,betta,delta,p,T,k);
        iter = iter +1;
    end
disp('*****************')
disp('     Results')
disp('*****************')
disp(['Gamma = ' num2str(gamma) ' (' num2str(stderrors(1)) ')'])
disp(['J statistic = ' num2str(T*J)])
disp('*****************')

else 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp ('exercise 2: jointly estimate alpha, gamma, delta')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Parameters calibrate betta, estimate delta alpha, gamma
betta = .95;   
guess = [1 1 1]; % this is the initial guess for gamma alpha delta
p=1;
iter = 1;
WW = eye(4);             % Step One of the GMM algorithm
TT = length(data);
maxiter = 10;           
 
while iter <= maxiter;
        [results,J,ef,out,grad,Hessian]= fminunc(@model1_exa2,guess,[],data,betta,p,TT,WW);
        gamma = results(1);
        alpha = results(2);
        delta = results(3);
        
        stderrors = sqrt(diag(Hessian));
    
        % Calculate the Optimal Weight Matrix (Step Two)
        k=2;   % order of autocovariances to include in optimal W
        WW = varcovx2(gamma,alpha,data,betta,delta,p,TT,k);
        iter = iter +1;
    end
disp('*****************')
disp('     Results')
disp('*****************')
disp(['Gamma = ' num2str(gamma) ' (' num2str(stderrors(1)) ')'])
disp(['Alpha = ' num2str(alpha) ' (' num2str(stderrors(2)) ')'])
disp(['Gamma = ' num2str(delta) ' (' num2str(stderrors(3)) ')'])
disp(['J statistic = ' num2str(TT*J)])
disp('*****************')

end


 

