function W = varcov(gamma,alpha,data,beta,delta,p,T);

% eps, A, PI are (N-1) x 1 vectors
% W is a 2 x 2 matrix
for t = 1:T-1
    eps(t,1) = data(1,t)-(1/gamma)*(beta*(alpha*data(3,t+1) + p*(1-delta)...
               + (gamma/2)*data(1,t+1)^2 + gamma*(1-delta)*data(1,t+1)) - p);
end

% Evaluate the Moments at the Parameters estimated with W = I
A = data(2,1:T-1)';
PI = data(3,1:T-1)';
S = diag(diag(eps*eps'));    % This gives a diagonal matrix with eps(i)^2 on the diagonal
                             % and zeros elsewhere.  The first "diag"
                             % command outputs a column vector composed of
                             % elements of the main diagonal, while the
                             % second one takes this column vector and
                             % makes it into a square matrix.

W = inv(1/T*[A'; PI']*S*[A PI]); % inverse of the average square of the moments