function W = varcovx(gamma,alpha,data,beta,delta,p,T,k);
 
% g, A, PI are (N-1) x 1 vectors
% W is a 2 x 2 matrix
for t = 1:T-2
    g(t,1) = data(1,t)-(1/gamma)*(beta*(alpha*data(3,t+1) + p*(1-delta)...
               + (gamma/2)*data(1,t+1)^2 + gamma*(1-delta)*data(1,t+1)) - p);
end

A = data(2,2:T-1)';
PI = data(3,2:T-1)';
 
temp=g*g';                % var-cov-matrix of g
S=zeros(size(temp));
for i=-k:k
    S=S+diag(diag(temp,i),i); % extract the -k to k'th diagonals of temp
end

W = inv(1/T*[A'; PI']*S*[A PI]); % inverse of the average square of the moments